ARG BUILD_ARG_APP_GROUP_ID=65534
ARG BUILD_ARG_APP_USER_ID=65534

ARG BUILD_ARG_ALPINE_VERSION="latest"
ARG BUILD_ARG_NGINX_VERSION="1.24.0"

FROM alpine:${BUILD_ARG_ALPINE_VERSION} as server-raw
ARG BUILD_ARG_NGINX_VERSION
WORKDIR /app/
COPY ./images/server/stages/server-raw/rootfs/ /
RUN /build.d/bin/install.sh

FROM server-raw as server-debug
COPY ./images/server/stages/server-debug/rootfs/ /
STOPSIGNAL SIGTERM
ENTRYPOINT ["/entrypoint.sh"]
CMD ["nginx"]

FROM server-debug as server
ARG BUILD_ARG_APP_GROUP_ID
ARG BUILD_ARG_APP_USER_ID
ARG BUILD_ARG_NGINX_VERSION
RUN /build.d/bin/pre-build.sh
RUN /build.d/bin/post-build.sh
USER www-data:www-data

FROM alpine:${BUILD_ARG_ALPINE_VERSION} as server-modules-build
ARG BUILD_ARG_NGINX_VERSION
WORKDIR /build/
COPY ./images/server/stages/server-modules-build/rootfs/ /
RUN /build.d/bin/install.sh

FROM scratch as server-modules
COPY --from=server-modules-build /etc/nginx/modules/ /etc/nginx/modules/
